----------------------------------------------------------
-- Example(4-23): FSM (Finite State Machine) modeling
-- Two concurrent processes and four state
----------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
----------------------------------------------------------
entity MOORE is -- Moore machine
       port(X, CLOCK: in BIT;
            Z: out BIT);
end MOORE;
----------------------------------------------------------

architecture BEHAVIOR of MOORE is
    type STATE_TYPE is (S0, S1, S2, S3);
    signal CURRENT_STATE, NEXT_STATE: STATE_TYPE;
begin
----------------------------------------------------------
COMBIN: process(CURRENT_STATE, X) -- combinational logic
begin
  case CURRENT_STATE is
  when S0 => 
       Z <= '0';
       if X = '0' then
          NEXT_STATE <= S0;
       else
          NEXT_STATE <= S2;
       end if;
  when S1 =>
       Z <= '1';
       if X = '0' then
          NEXT_STATE <= S0;
       else
          NEXT_STATE <= S2;
       end if;
  when S2 =>
       Z <= '1';
       if X = '0' then
          NEXT_STATE <= S2;
       else
          NEXT_STATE <= S3;
       end if;
  when S3 =>
       Z <= '0';
       if X ='0' then
          NEXT_STATE <= S3;
       else
          NEXT_STATE <= S1;
       end if;
  end case;
end process COMBIN;
----------------------------------------------------------
SYNCH: process  -- hold synchronous elements (flip-flops)
begin
  wait until CLOCK'event and CLOCK = '1';
  CURRENT_STATE <= NEXT_STATE;
end process SYNCH;
end BEHAVIOR; 
----------------------------------------------------------
