----------------------------------------------------------
-- Example(4-25): FSM (Finite State Machine) modeling
-- Detector of “1110101101” Sequence (Moore machine)
----------------------------------------------------------
LIBRARY ieee;
Use ieee.std_logic_1164.all;
----------------------------------------------------------
ENTITY seqdetector IS
PORT	(clk, reset		:IN  STD_LOGIC;
		input		:IN  STD_LOGIC;
		output	:OUT STD_LOGIC );
END seqdetector ;
----------------------------------------------------------
ARCHITECTURE stat OF seqdetector IS
TYPE STATE_TYPE IS (s0, s1, s2, s3 , s4, s5, s6, s7, s8, s9, s10);
SIGNAL state, next_state : STATE_TYPE;
BEGIN
----------------------------------------------------------
state_register: PROCESS (clk, reset)
BEGIN
	IF reset = '0' THEN
		state <= s0;
		output<='0';
	ELSIF clk'EVENT AND clk = '1' THEN
		state <= next_state;
	END IF;
END PROCESS state_register;
----------------------------------------------------------
state_logic : PROCESS ( state )
	BEGIN
	CASE state IS
		WHEN s0 =>				 --detect "1"
			output<='0';
			IF (input='1') THEN
			next_state <=s1;
			ELSIF (input='0') THEN
			next_state <=s0;
			END IF;
		WHEN s1 =>				--detect "11"
			output<='0';
			IF (input='1') THEN
			next_state <=s2;
			ELSIF (input='0') THEN
			next_state <=s0;
			END IF;

		WHEN s2 =>				--detect "111"
			output<='0';
			IF (input='1') THEN
			next_state <=s3;
			ELSIF (input='0') THEN
			next_state <=s0;
			END IF;

		WHEN s3 =>				--detect "1110"			output<='0';
			IF (input='0') THEN
			next_state <=s4;
			ELSIF (input='1') THEN
			next_state <=s2;
			END IF;

		WHEN s4 =>			--detect "11101"	
			output<='0';
			IF (input='1') THEN
			next_state <=s5;
			ELSIF (input='0') THEN
			next_state <=s0;
			END IF;

		WHEN s5 => 			--detect "111010" 
			output<='0';
			IF (input='0') THEN
			next_state <=s6;
			ELSIF (input='1') THEN
			next_state <=s2;
			END IF;

		WHEN s6 =>			--detect "1110101"
			output<='0';
			IF (input='1') THEN
			next_state <=s7;
			ELSIF (input='0') THEN
			next_state <=s0;
			END IF;
		WHEN s7 =>			--detect "11101011"
			output<='0';
			IF (input='1') THEN
			next_state <=s8;
			ELSIF (input='0') THEN
			next_state <=s0;
			END IF;

		WHEN s8 =>			--detect "111010110" 
			output<='0';
			IF (input='0') THEN
			next_state <=s9;
			ELSIF (input='1') THEN
			next_state <=s2;
			END IF;

		WHEN s9 =>			--detect "1110101101"
			output<='0';
			IF (input='1') THEN
			next_state <=s10;
			ELSIF (input='1') THEN
			next_state <=s0;
			END IF;

		WHEN s10 =>			-- output asserted
			output<='1';
			next_state<=s0;

		END CASE;

		END PROCESS state_logic;
END stat;
----------------------------------------------------------



