----------------------------------------------------------
-- Example(4-26): FSM (Finite State Machine) modeling
-- Moore machine   Compare it with Example(4-23) 
----------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
----------------------------------------------------------
entity MEALY is -- Mealy machine
       port(X, CLOCK: in BIT; Z: out BIT );
end MEALY;
----------------------------------------------------------
architecture BEHAVIOR of MEALY is
     type STATE_TYPE is (S0, S1, S2, S3);
     signal CURRENT_STATE, NEXT_STATE: STATE_TYPE;
begin
----------------------------------------------------------
-- Process to hold combinational logic.
  COMBIN: process(CURRENT_STATE, X)
  begin
  case CURRENT_STATE is
  when S0 =>
       if X = '0' then 
          Z <= '0';
          NEXT_STATE <= S0;
       else
          Z <= '1';
          NEXT_STATE <= S2;
       end if;
  when S1 =>
       if X = '0' then
          Z <= '0';
          NEXT_STATE <= S0;
       else
          Z <= '0';
          NEXT_STATE <= S2;
       end if;
  when S2 =>
       if X = '0' then
          Z <= '1';
          NEXT_STATE <= S2;
       else
          Z <= '0';
          NEXT_STATE <= S3;
       end if;
  when S3 =>
       if X = '0' then
          Z <= '0';
          NEXT_STATE <= S3;
       else
          Z <= '1';
          NEXT_STATE <= S1;
       end if;
end case;
end process COMBIN;
----------------------------------------------------------
-- Process to hold synchronous elements (flip-flops)
SYNCH: process
begin
  wait until CLOCK'event and CLOCK = '1';
  CURRENT_STATE <= NEXT_STATE;
end process SYNCH;
end BEHAVIOR;
----------------------------------------------------------
