----------------------------------------------------------
-- Example(4-31): ROM 88 
----------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
----------------------------------------------------------
ENTITY rom IS
   GENERIC (bits: INTEGER := 8; words: INTEGER := 8);
      PORT (Addr	: IN INTEGER RANGE 0 TO words-1;
		Enable, Read: in std_logic;
Data  : OUT STD_LOGIC_VECTOR(bits-1 DOWNTO 0));
END rom;
----------------------------------------------------------
ARCHITECTURE rom OF rom IS
    TYPE vector_array IS ARRAY (0 TO words-1) OF 
         STD_LOGIC_VECTOR (bits-1 DOWNTO 0);
    ONSTANT memory: vector_array :=(
         "10000000", "01000000", "00100000", "00010000",    
         "00001000", "00000100", "00000010", "00000001");
BEGIN
    process( Enable, Read, Addr)
    begin
	  if Enable = '1' then
		if( Read = '1' ) then
		    	data <= memory(addr);
            else Data <= "ZZZZZZZZ";
            end if;
        else Data <= "ZZZZZZZZ";
	  end if;
    end process;
END rom;
----------------------------------------------------------
