----------------------------------------------------------
-- Simple Microprocessor Design (microprocessor.vhd)
-- structural modeling Microprocessor 
-- composed of Ctrl_Unit, Data_Path and Memory
---------------------------------------------------------- 
Library ieee;
use ieee.std_logic_1164.all;  
use ieee.std_logic_unsigned.all;
---------------------------------------------------------- 
entity microprocessor is
port( 	cpu_clk:	in std_logic;
		cpu_rst:	in std_logic;
		cpu_output:	out std_logic_vector(15 downto 0));
end microprocessor;
---------------------------------------------------------- 
architecture structure of microprocessor is
signal addr_bus,mdin_bus,mdout_bus,immd_bus,rfout_bus: 
std_logic_vector(15 downto 0);  
signal mem_addr: std_logic_vector(7 downto 0);
signal RFwa_s,RFr1a_s,RFr2a_s:std_logic_vector(3 downto 0);
signal RFwe_s, RFr1e_s, RFr2e_s: std_logic;
signal ALUs_s, RFs_s: std_logic_vector(1 downto 0);
signal IRld_s, PCld_s, PCinc_s, PCclr_s: std_logic;
signal Mre_s, Mwe_s, jpz_s, oe_s: std_logic;
begin
	mem_addr <= addr_bus(7 downto 0); 
	Unit0: entity work.ctrl_unit port map(cpu_clk, 
             cpu_rst,PCld_s, mdout_bus, rfout_bus, 
             addr_bus, immd_bus, RFs_s, RFwa_s, RFr1a_s,
             RFr2a_s, RFwe_s, RFr1e_s, RFr2e_s, jpz_s, 
             ALUs_s, Mre_s, Mwe_s, oe_s);
	Unit1: entity work.datapath port map(cpu_clk, 
             cpu_rst, immd_bus, mdout_bus, RFs_s, RFwa_s,   
             RFr1a_s,RFr2a_s,RFwe_s, RFr1e_s, RFr2e_s, 
             jpz_s, ALUs_s, oe_s, PCld_s, rfout_bus, 
             mdin_bus, cpu_output);
Unit2: entity work.memory port map(	cpu_clk, cpu_rst, 
       Mre_s, Mwe_s,mem_addr, mdin_bus, mdout_bus );
end structure;
---------------------------------------------------------- 
